regina::NormalSurfaces Class Referenceabstract
Normal Surfaces

A packet representing a collection of normal surfaces in a 3-manifold. More...

`#include <surfaces/normalsurfaces.h>`

Inheritance diagram for regina::NormalSurfaces:

## Classes

struct | SurfaceInserter
| An output iterator used to insert surfaces into an NormalSurfaces. More...
class | VectorIterator
| A bidirectional iterator that runs through the raw vectors for surfaces in this list. More...

## Public Types

typedef Packet | SafePointeeType
| The type of object being pointed to. More...

## Public Member Functions

virtual | ~NormalSurfaces ()
| Destroys this list and all the surfaces within. More...
NormalCoords | coords () const
| Returns the coordinate system being used by the surfaces stored in this set. More...
NormalList | which () const
| Returns details of which normal surfaces this list represents within the underlying triangulation. More...
NormalAlg | algorithm () const
| Returns details of the algorithm that was used to enumerate this list. More...
bool | allowsAlmostNormal () const
| Determines if the coordinate system being used allows for almost normal surfaces, that is, allows for octagonal discs. More...
bool | allowsSpun () const
| Determines if the coordinate system being used allows for spun normal surfaces. More...
bool | allowsOriented () const
| Determines if the coordinate system being used allows for transversely oriented normal surfaces. More...
bool | isEmbeddedOnly () const
| Returns whether this list was constructed to contain only properly embedded surfaces. More...
Triangulation< 3 > * | triangulation () const
| Returns the triangulation in which these normal surfaces live. More...
size_t | size () const
| Returns the number of surfaces stored in this list. More...
const NormalSurface * | surface (size_t index) const
| Returns the surface at the requested index in this set. More...
void | writeAllSurfaces (std::ostream &out) const
| Writes the number of surfaces in this set followed by the details of each surface to the given output stream. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
NormalSurfaces * | quadToStandard () const
| Converts the set of all embedded vertex normal surfaces in quadrilateral space to the set of all embedded vertex normal surfaces in standard (tri-quad) space. More...
NormalSurfaces * | quadOctToStandardAN () const
| Converts the set of all embedded vertex almost normal surfaces in quadrilateral-octagon space to the set of all embedded vertex almost normal surfaces in the standard tri-quad-oct space. More...
NormalSurfaces * | standardToQuad () const
| Converts the set of all embedded vertex normal surfaces in standard (tri-quad) space to the set of all embedded vertex normal surfaces in quadrilateral space. More...
NormalSurfaces * | standardANToQuadOct () const
| Converts the set of all embedded vertex almost normal surfaces in standard tri-quad-oct space to the set of all embedded vertex almost normal surfaces in the smaller quadrilateral-octagon space. More...
NormalSurfaces * | filterForLocallyCompatiblePairs () const
| Creates a new list filled with the surfaces from this list that have at least one locally compatible partner. More...
NormalSurfaces * | filterForDisjointPairs () const
| Creates a new list filled with the surfaces from this list that have at least one disjoint partner. More...
NormalSurfaces * | filterForPotentiallyIncompressible () const
| Creates a new list filled with only the surfaces from this list that "might" represent two-sided incompressible surfaces. More...
MatrixInt * | recreateMatchingEquations () const
| Returns a newly created matrix containing the matching equations that were used to create this normal surface list. More...
bool | saveCSVStandard (const char *filename, int additionalFields=regina::surfaceExportAll)
| Exports this list of normal surfaces as a plain text CSV (comma-separated value) file, using standard coordinates. More...
bool | saveCSVEdgeWeight (const char *filename, int additionalFields=regina::surfaceExportAll)
| Exports the given list of normal surfaces as a plain text CSV (comma-separated value) file, using edge weight coordinates. More...
VectorIterator | beginVectors () const
| An iterator that gives access to the raw vectors for surfaces in this list, pointing to the beginning of this surface list. More...
VectorIterator | endVectors () const
| An iterator that gives access to the raw vectors for surfaces in this list, pointing past the end of this surface list. More...
bool | hasOwner () const
| Indicates whether some other object in the calculation engine is responsible for ultimately destroying this object. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...
Packet Identification
virtual PacketType | type () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | typeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | label () const
| Returns the label associated with this individual packet. More...
std::string | humanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
std::string | adornedLabel (const std::string &adornment) const
| Returns the label of this packet adorned with the given string. More...
void | setLabel (const std::string &label)
| Sets the label associated with this individual packet. More...
std::string | fullName () const
| Returns a descriptive text string for the packet. More...
Tags
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | tags () const
| Returns the set of all tags associated with this packet. More...
Event Handling
bool | listen (PacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (PacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (PacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
Tree Queries
Packet * | parent () const
| Determines the parent packet in the tree structure. More...
Packet * | firstChild () const
| Determines the first child of this packet in the tree structure. More...
Packet * | lastChild () const
| Determines the last child of this packet in the tree structure. More...
Packet * | nextSibling () const
| Determines the next sibling of this packet in the tree structure. More...
Packet * | prevSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
Packet * | root () const
| Determines the root of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const Packet *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const Packet *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const Packet *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
size_t | countChildren () const
| Returns the number of immediate children of this packet. More...
size_t | countDescendants () const
| Returns the total number of descendants of this packet. More...
size_t | totalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
Tree Manipulation
void | insertChildFirst (Packet *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (Packet *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (Packet *newChild, Packet *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (Packet *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | transferChildren (Packet *newParent)
| Cuts all of this packet's children out of the packet tree, and reinserts them as children of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
Searching and Iterating
Packet * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const Packet * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
Packet * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const Packet * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
Packet * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const Packet * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
Packet * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const Packet * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
Packet Dependencies
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
Cloning
Packet * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
File I/O
bool | save (const char *filename, bool compressed=true) const
| Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format. More...
bool | save (std::ostream &s, bool compressed=true) const
| Writes the subtree rooted at this packet to the given output stream, in the format of a Regina XML data file. More...
void | writeXMLFile (std::ostream &out) const
| Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...

## Static Public Member Functions

static NormalSurfaces * | enumerate (Triangulation< 3 > *owner, NormalCoords coords, NormalList which=NS_LIST_DEFAULT, NormalAlg algHints=NS_ALG_DEFAULT, ProgressTracker *tracker=0)
| A unified routine for enumerating various classes of normal surfaces within a given triangulation. More...
static XMLPacketReader * | xmlReader (Packet *parent, XMLTreeResolver &resolver)

## Protected Member Functions

| NormalSurfaces (NormalCoords coords, NormalList which, NormalAlg algorithm)
| Creates an empty list of normal surfaces with the given parameters. More...
virtual Packet * | internalClonePacket (Packet *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...

## Protected Attributes

std::vector< NormalSurface * > | surfaces
| Contains the normal surfaces stored in this packet. More...
NormalCoords | coords_
| Stores which coordinate system is being used by the normal surfaces in this packet. More...
NormalList | which_
| Indicates which normal surfaces these represent within the underlying triangulation. More...
NormalAlg | algorithm_
| Stores the details of the enumeration algorithm that was used to generate this list. More...

## Friends

class | XMLNormalSurfacesReader

## Detailed Description

A packet representing a collection of normal surfaces in a 3-manifold.

Such a packet must always be a child packet of the triangulation from which the surfaces were obtained. If this triangulation changes, the information contained in this packet will become invalid.

See the NormalSurfaceVector class notes for details of what to do when introducing a new coordinate system.

Normal surface lists should be created using the routine enumerate().

Todo:

  Feature: Allow custom matching equations.

  Feature: Allow enumeration with some coordinates explicitly set to zero.

  Feature: Allow generating only closed surfaces.

  Feature: Generate facets of the solution space representing embedded surfaces.

## Member Typedef Documentation

## SafePointeeType

typedef Packet regina::SafePointeeBase< Packet >::SafePointeeType

inherited

The type of object being pointed to.

## Constructor & Destructor Documentation

## ~NormalSurfaces()

regina::NormalSurfaces::~NormalSurfaces | ( |  | ) |

inline virtual

Destroys this list and all the surfaces within.

## NormalSurfaces()

regina::NormalSurfaces::NormalSurfaces | ( | NormalCoords | coords,
|  | NormalList | which,
|  | NormalAlg | algorithm
| ) |  |

inline protected

Creates an empty list of normal surfaces with the given parameters.

Parameters

  coords | the coordinate system to be used for filling this list.
  which | indicates which normal surfaces these will represent within the underlying triangulation.
  algorithm | details of the enumeration algorithm that will be used to fill this list.

## Member Function Documentation

## addTag()

bool regina::Packet::addTag | ( | const std::string & | tag | ) |

inherited

Associates the given tag with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Precondition
  The given tag is not the empty string.

Parameters

  tag | the tag to add.

Returns
  `true` if the given tag was successfully added, or `false` if the given tag was already present beforehand.

## adornedLabel()

std::string regina::Packet::adornedLabel | ( | const std::string & | adornment | ) | const

inherited

Returns the label of this packet adorned with the given string.

An adornment typically shows how a packet has been created and/or modified. For instance, the adornment argument might be "Filled", or "Summand #1".

The way in which the packet label is adorned depends upon the label itself (in particular, an empty packet label will be handled in a sensible way). The way in which the packet label is adorned is subject to change in future versions of Regina.

Note that, whilst this routine returns a modified version of the packet label, the label itself will not be permamently changed.

Parameters

  adornment | the string that will be used to adorn this packet label. The adornment should just be a piece of English, ideally beginning with an upper-case letter. It should not contain any surrounding punctuation such as brackets or a dash (this will be added automatically by this routine as required).

Returns
  a copy of the packet label with the given adornment.

## algorithm()

NormalAlg regina::NormalSurfaces::algorithm | ( |  | ) | const

inline

Returns details of the algorithm that was used to enumerate this list.

These may not be the same NormalAlg flags that were passed to enumerate(). In particular, default values will have been explicitly filled in, invalid and/or redundant values will have been removed, and unavailable and/or unsupported combinations of algorithm flags will be replaced with whatever algorithm was actually used.

Returns
  details of the algorithm used to enumerate this list.

## allowsAlmostNormal()

bool regina::NormalSurfaces::allowsAlmostNormal | ( |  | ) | const

Determines if the coordinate system being used allows for almost normal surfaces, that is, allows for octagonal discs.

Returns
  `true` if and only if almost normal surfaces are allowed.

## allowsOriented()

bool regina::NormalSurfaces::allowsOriented | ( |  | ) | const

Determines if the coordinate system being used allows for transversely oriented normal surfaces.

Returns
  `true` if and only if transverse orientations are supported.

## allowsSpun()

bool regina::NormalSurfaces::allowsSpun | ( |  | ) | const

Determines if the coordinate system being used allows for spun normal surfaces.

Returns
  `true` if and only if spun normal surface are supported.

## beginVectors()

NormalSurfaces::VectorIterator regina::NormalSurfaces::beginVectors | ( |  | ) | const

inline

An iterator that gives access to the raw vectors for surfaces in this list, pointing to the beginning of this surface list.

Python:
  Not present.

Returns
  an iterator at the beginning of this surface list.

## clone()

Packet* regina::Packet::clone | ( | bool | cloneDescendants = `false`,
|  | bool | end = `true`
| ) |  | const

inherited

Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet.

Note that any string tags associated with this packet will not be cloned.

If this packet has no parent in the tree structure, no clone will be created and 0 will be returned.

Parameters

  cloneDescendants | `true` if the descendants of this packet should also be cloned and inserted as descendants of the new packet. If this is passed as `false` (the default), only this packet will be cloned.
  end | `true` if the new packet should be inserted at the end of the parent's list of children (the default), or `false` if the new packet should be inserted as the sibling immediately after this packet.

Returns
  the newly inserted packet, or 0 if this packet has no parent.

## coords()

NormalCoords regina::NormalSurfaces::coords | ( |  | ) | const

inline

Returns the coordinate system being used by the surfaces stored in this set.

Returns
  the coordinate system used.

## countChildren()

size_t regina::Packet::countChildren | ( |  | ) | const

inherited

Returns the number of immediate children of this packet.

Grandchildren and so on are not counted.

Returns
  the number of immediate children.

## countDescendants()

size_t regina::Packet::countDescendants | ( |  | ) | const

inline inherited

Returns the total number of descendants of this packet.

This includes children, grandchildren and so on. This packet is not included in the count.

Returns
  the total number of descendants.

## dependsOnParent()

bool regina::NormalSurfaces::dependsOnParent | ( |  | ) | const

inline virtual

Determines if this packet depends upon its parent.

This is true if the parent cannot be altered without invalidating or otherwise upsetting this packet.

Returns
  `true` if and only if this packet depends on its parent.

Implements regina::Packet.

## detail()

std::string regina::Output< Packet , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## endVectors()

NormalSurfaces::VectorIterator regina::NormalSurfaces::endVectors | ( |  | ) | const

inline

An iterator that gives access to the raw vectors for surfaces in this list, pointing past the end of this surface list.

This iterator is not dereferenceable.

Python:
  Not present.

Returns
  an iterator past the end of this surface list.

## enumerate()

static NormalSurfaces* regina::NormalSurfaces::enumerate | ( | Triangulation< 3 > * | owner,
|  | NormalCoords | coords,
|  | NormalList | which = `NS_LIST_DEFAULT`,
|  | NormalAlg | algHints = `NS_ALG_DEFAULT`,
|  | ProgressTracker * | tracker = `0`
| ) |  |

static

A unified routine for enumerating various classes of normal surfaces within a given triangulation.

The NormalCoords argument allows you to specify an underlying coordinate system (e.g., standard coordinates, quadrilateral coordinates or almost normal coordinates).

The NormalList argument is a combination of flags that allows you to specify exactly which normal surfaces you require. This includes (i) whether you want all vertex surfaces or all fundamental surfaces, which defaults to NS_VERTEX if you specify neither or both; and (ii) whether you want only properly embedded surfaces or you also wish to include immersed and/or singular surfaces, which defaults to NS_EMBEDDED_ONLY if you specify neither or both.

The NormalAlg argument is a combination of flags that allows you to control the underlying enumeration algorithm. These flags are treated as hints only: if your selection of algorithm is invalid, unavailable or unsupported then Regina will choose something more appropriate. Unless you have some specialised need, the default NS_ALG_DEFAULT (which makes no hints at all) will allow Regina to choose what it thinks will be the most efficient method.

The enumerated surfaces will be stored in a new normal surface list, and their representations will be scaled down to use the smallest possible integer coordinates. This normal surface list will be inserted into the packet tree as the last child of the given triangulation. This triangulation must remain the parent of this normal surface list, and must not change while this normal surface list remains in existence.

If a progress tracker is passed, the normal surface enumeration will take place in a new thread and this routine will return immediately. If the user cancels the operation from another thread, then the normal surface list will not be inserted into the packet tree (but the caller of this routine will still need to delete it). Regarding progress tracking, this routine will declare and work through a series of stages whose combined weights sum to 1; typically this means that the given tracker must not have been used before.

If no progress tracker is passed, the enumeration will run in the current thread and this routine will return only when the enumeration is complete. Note that this enumeration can be extremely slow for larger triangulations.

Parameters

  owner | the triangulation upon which this list of normal surfaces will be based.
  coords | the coordinate system to be used.
  which | indicates which normal surfaces should be enumerated.
  algHints | passes requests to Regina for which specific enumeration algorithm should be used.
  tracker | a progress tracker through which progress will be reported, or 0 if no progress reporting is required.

Returns
  the newly created normal surface list. Note that if a progress tracker is passed then this list may not be completely filled when this routine returns. If a progress tracker is passed and a new thread could not be started, this routine returns 0 (and no normal surface list is created).

## filterForDisjointPairs()

NormalSurfaces* regina::NormalSurfaces::filterForDisjointPairs | ( |  | ) | const

Creates a new list filled with the surfaces from this list that have at least one disjoint partner.

In other words, a surface S from this list will be placed in the new list if and only if there is some other surface T in this list for which S and T can be made to intersect nowhere at all, without changing either normal isotopy class. See NormalSurface::disjoint() for further details on disjointness testing.

This routine cannot deal with empty, disconnected or non-compact surfaces. Such surfaces will be silently ignored, and will not be used in any disjointness tests (in particular, they will never be considered as a "disjoint partner" for any other surface).

The new list will be inserted as a new child packet of the underlying triangulation (specifically, as the final child). As a convenience, the new list will also be returned from this routine.

This original list is not altered in any way. Likewise, the surfaces in the new list are deep copies of the originals (so they can be altered without affecting the original surfaces).

Precondition
  This list contains only embedded normal surfaces. More precisely, isEmbeddedOnly() must return `true`.
  All surfaces within this list are stored using the same coordinate system (i.e., the same subclass of NormalSurfaceVector).

Warning
  If this list contains a vertex link (plus at least one other surface), then the new list will be identical to the old (i.e., every surface will be copied across).

Todo:
  Deal properly with surfaces that are too large to handle.

Returns
  the new list, which will also have been inserted as a new child packet of the underlying triangulation.

## filterForLocallyCompatiblePairs()

NormalSurfaces* regina::NormalSurfaces::filterForLocallyCompatiblePairs | ( |  | ) | const

Creates a new list filled with the surfaces from this list that have at least one locally compatible partner.

In other words, a surface S from this list will be placed in the new list if and only if there is some other surface T in this list for which S and T are locally compatible. See NormalSurface::locallyCompatible() for further details on compatibility testing.

The new list will be inserted as a new child packet of the underlying triangulation (specifically, as the final child). As a convenience, the new list will also be returned from this routine.

This original list is not altered in any way. Likewise, the surfaces in the new list are deep copies of the originals (so they can be altered without affecting the original surfaces).

Precondition
  This list contains only embedded normal surfaces. More precisely, isEmbeddedOnly() must return `true`.

Warning
  If this list contains a vertex link (plus at least one other surface), then the new list will be identical to the old (i.e., every surface will be copied across).

Returns
  the new list, which will also have been inserted as a new child packet of the underlying triangulation.

## filterForPotentiallyIncompressible()

NormalSurfaces* regina::NormalSurfaces::filterForPotentiallyIncompressible | ( |  | ) | const

Creates a new list filled with only the surfaces from this list that "might" represent two-sided incompressible surfaces.

More precisely, we consider all two-sided surfaces in this list, as well as the two-sided double covers of all one-sided surfaces in this list (see below for details on how one-sided surfaces are handled). Each of these surfaces is examined using relatively fast heuristic tests for incompressibility. Any surface that is definitely not incompressible is thrown away, and all other surfaces are placed in the new list.

Therefore, it is guaranteed that every incompressible surface from the old list will be placed in the new list. However, it is not known whether any given surface in the new list is indeed incompressible.

See NormalSurface::isIncompressible() for the definition of incompressibility that is used here. Note in particular that spheres are never considered incompressible.

As indicated above, this filter works exclusively with two-sided surfaces. If a surface in this list is one-sided, the heuristic incompressibility tests will be run on its two-sided double cover. Nevertheless, if the tests pass, the original one-sided surface (not the double cover) will be added to the new list.

The new list will be inserted as a new child packet of the underlying triangulation (specifically, as the final child). As a convenience, the new list will also be returned from this routine.

This original list is not altered in any way. Likewise, the surfaces in the new list are deep copies of the originals (so they can be altered without affecting the original surfaces).

Currently the heuristic tests include (i) throwing away all vertex links and thin edge links, and then (ii) cutting along the remaining surfaces and running Triangulation<3>::hasSimpleCompressingDisc() on the resulting bounded triangulations. For more details on these tests see "The Weber-Seifert dodecahedral space is non-Haken", Benjamin A. Burton, J. Hyam Rubinstein and Stephan Tillmann, Trans. Amer. Math. Soc. 364:2 (2012), pp. 911-932.

Precondition
  The underlying 3-manifold triangulation is valid and closed. In particular, it has no ideal vertices.
  This list contains only embedded normal surfaces. More precisely, isEmbeddedOnly() must return `true`.
  This list contains only compact, connected normal surfaces.
  No surfaces in this list contain any octagonal discs.

Warning
  The behaviour of this routine is subject to change in future versions of Regina, since additional tests may be added to improve the power of this filtering.

Todo:
  Add progress tracking.

Returns
  the new list, which will also have been inserted as a new child packet of the underlying triangulation.

## findPacketLabel() [1/2]

Packet* regina::Packet::findPacketLabel | ( | const std::string & | label | ) |

inherited

Finds the packet with the requested label in the tree or subtree for which this packet is matriarch.

Note that label comparisons are case sensitive.

Parameters

  label | the label to search for.

Returns
  the packet with the requested label, or 0 if there is no such packet.

## findPacketLabel() [2/2]

const Packet* regina::Packet::findPacketLabel | ( | const std::string & | label | ) | const

inherited

Finds the packet with the requested label in the tree or subtree for which this packet is matriarch.

Note that label comparisons are case sensitive.

Parameters

  label | the label to search for.

Returns
  the packet with the requested label, or 0 if there is no such packet.

## firstChild()

Packet * regina::Packet::firstChild | ( |  | ) | const

inline inherited

Determines the first child of this packet in the tree structure.

This routine takes small constant time.

Returns
  the first child packet, or 0 if there is none.

## firstTreePacket() [1/2]

Packet* regina::Packet::firstTreePacket | ( | const std::string & | type | ) |

inherited

Finds the first packet of the requested type in a complete depth-first iteration of the tree structure.

Note that this packet must be the matriarch of the entire tree.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Parameters

  type | the type of packet to search for, as returned by typeName(). Note that string comparisons are case sensitive.

Returns
  the first such packet, or 0 if there are no packets of the requested type.

## firstTreePacket() [2/2]

const Packet* regina::Packet::firstTreePacket | ( | const std::string & | type | ) | const

inherited

Finds the first packet of the requested type in a complete depth-first iteration of the tree structure.

Note that this packet must be the matriarch of the entire tree.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Parameters

  type | the type of packet to search for, as returned by typeName(). Note that string comparisons are case sensitive.

Returns
  the first such packet, or 0 if there are no packets of the requested type.

## fullName()

std::string regina::Packet::fullName | ( |  | ) | const

inherited

Returns a descriptive text string for the packet.

The string is of the form label (packet-type).

The packet label will be adjusted for human-readable output according to the behaviour of humanLabel().

Returns
  the descriptive text string.

## hasOwner()

bool regina::Packet::hasOwner | ( |  | ) | const

inline inherited

Indicates whether some other object in the calculation engine is responsible for ultimately destroying this object.

For packets, this returns `true` if and only if this packet has a parent in the packet tree (i.e., is not the root).

Returns
  `true` if and only if some other object owns this object.

## hasTag()

bool regina::Packet::hasTag | ( | const std::string & | tag | ) | const

inline inherited

Determines whether this packet has the given associated tag.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Parameters

  tag | the tag to search for.

Returns
  `true` if the given tag is found, `false` otherwise.

## hasTags()

bool regina::Packet::hasTags | ( |  | ) | const

inline inherited

Determines whether this packet has any associated tags at all.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Returns
  `true` if this packet has any tags, `false` otherwise.

## humanLabel()

std::string regina::Packet::humanLabel | ( |  | ) | const

inline inherited

Returns the label associated with this individual packet, adjusted if necessary for human-readable output.

In particular, if the packet has no label assigned then this routine will return "(no label)", not the empty string.

Warning
  The method by which this routine adjusts packet labels is subject to change in future versions of Regina.

Returns
  this individual packet's label.

## insertChildAfter()

void regina::Packet::insertChildAfter | ( | Packet * | newChild,
|  | Packet * | prevChild
| ) |  |

inherited

Inserts the given packet as a child of this packet at the given location in this packet's child list.

This routine takes small constant time.

Precondition
  Parameter newChild has no parent packet.
  Parameter prevChild is already a child of this packet.
  This packet is not a descendant of newChild.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  newChild | the child to insert.
  prevChild | the preexisting child of this packet after which newChild will be inserted, or 0 if newChild is to be the first child of this packet.

## insertChildFirst()

void regina::Packet::insertChildFirst | ( | Packet * | child | ) |

inherited

Inserts the given packet as the first child of this packet.

This routine takes small constant time.

Precondition
  The given child has no parent packet.
  This packet is not a descendant of the given child.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  child | the child to insert.

## insertChildLast()

void regina::Packet::insertChildLast | ( | Packet * | child | ) |

inherited

Inserts the given packet as the last child of this packet.

This routine takes small constant time.

Precondition
  The given child has no parent packet.
  This packet is not a descendant of the given child.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  child | the child to insert.

## internalClonePacket()

virtual Packet* regina::NormalSurfaces::internalClonePacket | ( | Packet * | parent | ) | const

protected virtual

Makes a newly allocated copy of this packet.

This routine should not insert the new packet into the tree structure, clone the packet's associated tags or give the packet a label. It should also not clone any descendants of this packet.

You may assume that the new packet will eventually be inserted into the tree beneath either the same parent as this packet or a clone of that parent.

Parameters

  parent | the parent beneath which the new packet will eventually be inserted.

Returns
  the newly allocated packet.

Implements regina::Packet.

## internalID()

std::string regina::Packet::internalID | ( |  | ) | const

inherited

Returns a unique string ID that identifies this packet.

The user has no control over this ID, and it is not human readable. It is guaranteed to remain fixed throughout the lifetime of the program for a given packet, and it is guaranteed not to clash with the ID of any other packet.

If you change the contents of a packet, its ID will not change.

If you clone a packet, the new clone will receive a different ID. If you save and then load a packet to/from file, the ID will change. These behaviours are necessary to ensure that IDs remain unique (since, for instance, you could load several copies of the same data file into memory simultaneously).

The ID is implemented as an encoding of the underlying C++ pointer. This encoding is subject to change in later versions of Regina.

Returns
  a unique ID that identifies this packet.

## isEmbeddedOnly()

bool regina::NormalSurfaces::isEmbeddedOnly | ( |  | ) | const

inline

Returns whether this list was constructed to contain only properly embedded surfaces.

If this returns `false`, it does not guarantee that immersed and/or singular surfaces are present; it merely indicates that they were not deliberately excluded (for instance, the quadrilateral constraints were not enforced).

Returns
  `true` if this list was constructed to contain only properly embedded surfaces, or `false` otherwise.

## isGrandparentOf()

bool regina::Packet::isGrandparentOf | ( | const Packet * | descendant | ) | const

inherited

Determines if this packet is equal to or an ancestor of the given packet in the tree structure.

Parameters

  descendant | the other packet whose relationships we are examining.

Returns
  `true` if and only if this packet is equal to or an ancestor of `descendant`.

## isListening()

bool regina::Packet::isListening | ( | PacketListener * | listener | ) |

inline inherited

Determines whether the given packet listener is currently listening for events on this packet.

See the PacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to search for.

Returns
  `true` if the given listener is currently registered with this packet, or `false` otherwise.

## isPacketEditable()

bool regina::Packet::isPacketEditable | ( |  | ) | const

inherited

Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children.

Descendants further down the packet tree are not (and should not need to be) considered.

Returns
  `true` if and only if this packet may be edited.

## label()

const std::string & regina::Packet::label | ( |  | ) | const

inline inherited

Returns the label associated with this individual packet.

An example is `MyTriangulation`.

Returns
  this individual packet's label.

## lastChild()

Packet * regina::Packet::lastChild | ( |  | ) | const

inline inherited

Determines the last child of this packet in the tree structure.

This routine takes small constant time.

Returns
  the last child packet, or 0 if there is none.

## levelsDownTo()

unsigned regina::Packet::levelsDownTo | ( | const Packet * | descendant | ) | const

inherited

Counts the number of levels between this packet and its given descendant in the tree structure.

If `descendant` is this packet, the number of levels is zero.

Precondition
  This packet is equal to `descendant`, or can be obtained from `descendant` using only child-to-parent steps.

Parameters

  descendant | the packet whose relationship with this packet we are examining.

Returns
  the number of levels difference.

## levelsUpTo()

unsigned regina::Packet::levelsUpTo | ( | const Packet * | ancestor | ) | const

inline inherited

Counts the number of levels between this packet and its given ancestor in the tree structure.

If `ancestor` is this packet, the number of levels is zero.

Precondition
  This packet is equal to `ancestor`, or can be obtained from `ancestor` using only parent-to-child steps.

Parameters

  ancestor | the packet whose relationship with this packet we are examining.

Returns
  the number of levels difference.

## listen()

bool regina::Packet::listen | ( | PacketListener * | listener | ) |

inherited

Registers the given packet listener to listen for events on this packet.

See the PacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to register.

Returns
  `true` if the given listener was successfully registered, or `false` if the given listener was already registered beforehand.

## makeOrphan()

void regina::Packet::makeOrphan | ( |  | ) |

inherited

Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree.

The tree information for both this packet and its parent will be updated.

This routine takes small constant time.

Precondition
  This packet has a parent.
  This packet does not depend on its parent; see dependsOnParent() for details.

Python:
  After makeOrphan() is called, this packet will become the root of a new packet tree that is owned by Python. In particular, if you call makeOrphan() and then delete all Python references to this packet, the entire packet subtree will be automatically destroyed.

## moveDown()

void regina::Packet::moveDown | ( | unsigned | steps = `1` | ) |

inherited

Moves this packet the given number of steps towards the end of its sibling list.

If the number of steps is larger than the greatest possible movement, the packet will be moved to the very end of its sibling list.

This routine takes time proportional to the number of steps.

Precondition
  The given number of steps is strictly positive.

## moveToFirst()

void regina::Packet::moveToFirst | ( |  | ) |

inherited

Moves this packet to be the first in its sibling list.

This routine takes small constant time.

## moveToLast()

void regina::Packet::moveToLast | ( |  | ) |

inherited

Moves this packet to be the last in its sibling list.

This routine takes small constant time.

## moveUp()

void regina::Packet::moveUp | ( | unsigned | steps = `1` | ) |

inherited

Moves this packet the given number of steps towards the beginning of its sibling list.

If the number of steps is larger than the greatest possible movement, the packet will be moved to the very beginning of its sibling list.

This routine takes time proportional to the number of steps.

Precondition
  The given number of steps is strictly positive.

## nextSibling()

Packet * regina::Packet::nextSibling | ( |  | ) | const

inline inherited

Determines the next sibling of this packet in the tree structure.

This is the child of the parent that follows this packet.

This routine takes small constant time.

Returns
  the next sibling of this packet, or 0 if there is none.

## nextTreePacket() [1/4]

Packet* regina::Packet::nextTreePacket | ( |  | ) |

inherited

Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs.

Note that this packet need not be the tree matriarch.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Returns
  the next packet, or 0 if this is the last packet in such an iteration.

## nextTreePacket() [2/4]

const Packet* regina::Packet::nextTreePacket | ( |  | ) | const

inherited

Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs.

Note that this packet need not be the tree matriarch.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Returns
  the next packet, or 0 if this is the last packet in such an iteration.

## nextTreePacket() [3/4]

Packet* regina::Packet::nextTreePacket | ( | const std::string & | type | ) |

inherited

Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure.

Note that this packet need not be the tree matriarch. The order of tree searching is described in firstTreePacket().

Parameters

  type | the type of packet to search for, as returned by typeName(). Note that string comparisons are case sensitive.

Returns
  the next such packet, or 0 if this is the last packet of the requested type in such an iteration.

## nextTreePacket() [4/4]

const Packet* regina::Packet::nextTreePacket | ( | const std::string & | type | ) | const

inherited

Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure.

Note that this packet need not be the tree matriarch. The order of tree searching is described in firstTreePacket().

Parameters

  type | the type of packet to search for, as returned by typeName(). Note that string comparisons are case sensitive.

Returns
  the next such packet, or 0 if this is the last packet of the requested type in such an iteration.

## parent()

Packet * regina::Packet::parent | ( |  | ) | const

inline inherited

Determines the parent packet in the tree structure.

This routine takes small constant time.

Returns
  the parent packet, or 0 if there is none.

## prevSibling()

Packet * regina::Packet::prevSibling | ( |  | ) | const

inline inherited

Determines the previous sibling of this packet in the tree structure.

This is the child of the parent that precedes this packet.

This routine takes small constant time.

Returns
  the previous sibling of this packet, or 0 if there is none.

## quadOctToStandardAN()

NormalSurfaces* regina::NormalSurfaces::quadOctToStandardAN | ( |  | ) | const

Converts the set of all embedded vertex almost normal surfaces in quadrilateral-octagon space to the set of all embedded vertex almost normal surfaces in the standard tri-quad-oct space.

This routine is the almost normal analogue to the quadToStandard() conversion routine; see the quadToStandard() documentation for further information.

Precondition
  The underlying triangulation (the parent packet of this normal surface list) is valid, and the link of every vertex is either a sphere or a disc.
  This surface list is precisely the set of all embedded vertex almost normal surfaces in quadrilateral-octagon space; no more, no less. Moreover, these vectors are stored using quadrilateral-octagon coordinates. Typically this means that it was obtained through enumerate(), with the coordinate system set to NS_AN_QUAD_OCT and with embeddedOnly set to `true`.

Returns
  a full list of vertex almost normal surfaces in standard tri-quad-oct coordinates, or 0 if any of the basic sanity checks failed.

## quadToStandard()

NormalSurfaces* regina::NormalSurfaces::quadToStandard | ( |  | ) | const

Converts the set of all embedded vertex normal surfaces in quadrilateral space to the set of all embedded vertex normal surfaces in standard (tri-quad) space.

The initial list in quadrilateral space is taken to be this normal surface list; the final list in standard space will be inserted as a new child packet of the underlying triangulation (specifically, as the final child). As a convenience, the final list will also be returned from this routine.

This routine can only be used with normal surfaces, not almost normal surfaces. For almost normal surfaces, see the similar routine quadOctToStandardAN().

This procedure is available for any triangulation whose vertex links are all spheres and/or discs, and is much faster than enumerating surfaces directly in standard tri-quad coordinates. The underlying algorithm is described in detail in "Converting between quadrilateral and standard solution sets in normal surface theory", Benjamin A. Burton, Algebr. Geom. Topol. 9 (2009), 2121-2174.

Typically users do not need to call this routine directly, since the standard enumerate() routine will use it implicitly where possible. That is, when asked for standard vertex surfaces, enumerate() will first find all quadrilateral vertex surfaces and then use this procedure to convert them to standard vertex surfaces; this is generally orders of magnitude faster than enumerating surfaces directly in standard coordinates.

Nevertheless, this standalone routine is provided as a convenience for users who already have a set of quadrilateral vertex surfaces, and who simply wish to convert them to a set of standard vertex surfaces without the cost of implicitly enumerating the quadrilateral vertex surfaces again.

It should be noted that this routine does not simply convert vectors from one form to another; instead it converts a full solution set of vertex surfaces in quadrilateral coordinates to a full solution set of vertex surfaces in standard coordinates. Typically there are many more vertex surfaces in standard coordinates (all of which this routine will find).

This routine will run some very basic sanity checks before starting. Specifically, it will check the validity and vertex links of the underlying triangulation, and will verify that the coordinate system and embedded-only flag are set to NS_QUAD and `true` respectively. If any of these checks fails, this routine will do nothing and return 0.

Precondition
  The underlying triangulation (the parent packet of this normal surface list) is valid, and the link of every vertex is either a sphere or a disc.
  This normal surface list is precisely the set of all embedded vertex normal surfaces in quadrilateral space; no more, no less. Moreover, these vectors are stored using quadrilateral coordinates. Typically this means that it was obtained through enumerate(), with the coordinate system set to NS_QUAD and with embeddedOnly set to `true`.

Returns
  a full list of vertex normal surfaces in standard (tri-quad) coordinates, or 0 if any of the basic sanity checks failed.

## recreateMatchingEquations()

MatrixInt* regina::NormalSurfaces::recreateMatchingEquations | ( |  | ) | const

Returns a newly created matrix containing the matching equations that were used to create this normal surface list.

The destruction of this matrix is the responsibility of the caller of this routine. Multiple calls to this routine will result in the construction of multiple matrices. This routine in fact merely calls makeMatchingEquations() with the appropriate parameters.

The format of the matrix is identical to that returned by makeMatchingEquations().

Returns
  the matching equations used to create this normal surface list.

## removeAllTags()

void regina::Packet::removeAllTags | ( |  | ) |

inherited

Removes all associated tags from this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

## removeTag()

bool regina::Packet::removeTag | ( | const std::string & | tag | ) |

inherited

Removes the association of the given tag with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Parameters

  tag | the tag to remove.

Returns
  `true` if the given tag was removed, or `false` if the given tag was not actually associated with this packet.

## reparent()

void regina::Packet::reparent | ( | Packet * | newParent,
|  | bool | first = `false`
| ) |  |

inherited

Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead.

This routine is essentially a combination of makeOrphan() followed by either insertChildFirst() or insertChildLast().

This routine takes small constant time. It is safe to use regardless of whether this packet has a parent or not.

If you wish to reparent all of the children of a given packet, see transferChildren() instead.

Precondition
  This packet does not depend on its parent; see dependsOnParent() for details.
  The given parent is not a descendant of this packet.

Python:
  This routine is much simpler than combinations of makeOrphan() and insertChildFirst() / insertChildLast(), since there are no unpleasant ownership issues to deal with. However, if this packet currently has no parent then the ownership issues are unavoidable; in this case reparent() will do nothing, and one of the insertChild...() routines must be used instead.

Parameters

  newParent | the new parent of this packet, i.e., the packet beneath which this packet will be inserted.
  first | `true` if this packet should be inserted as the first child of the given parent, or `false` (the default) if it should be inserted as the last child.

## root()

Packet* regina::Packet::root | ( |  | ) | const

inherited

Determines the root of the tree to which this packet belongs.

Returns
  the matriarch of the packet tree.

## save() [1/2]

bool regina::Packet::save | ( | const char * | filename,
|  | bool | compressed = `true`
| ) |  | const

inherited

Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format.

The XML file may be optionally compressed (Regina can happily read both compressed and uncompressed XML).

This is the preferred way of saving a Regina data file. Typically this will be called from the root of the packet tree, which will save the entire packet tree to file.

Precondition
  The given packet does not depend on its parent.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. The contents of the file will be written using UTF-8.

Parameters

  filename | the pathname of the file to write to.
  compressed | `true` if the XML data should be compressed, or `false` if it should be written as plain text.

Returns
  `true` if and only if the file was successfully written.

## save() [2/2]

bool regina::Packet::save | ( | std::ostream & | s,
|  | bool | compressed = `true`
| ) |  | const

inherited

Writes the subtree rooted at this packet to the given output stream, in the format of a Regina XML data file.

The data file may be optionally compressed (Regina can happily read both compressed and uncompressed XML).

Typically this will be called from the root of the packet tree, which will write the entire packet tree to the given output stream.

Precondition
  The given stream is open for writing.
  The given packet does not depend on its parent.

Python:
  Not present.

Parameters

  s | the output stream to which to write.
  compressed | `true` if the XML data should be compressed, or `false` if it should be written as plain text.

Returns
  `true` if and only if the data was successfully written.

## saveCSVEdgeWeight()

bool regina::NormalSurfaces::saveCSVEdgeWeight | ( | const char * | filename,
|  | int | additionalFields = `regina::surfaceExportAll`
| ) |  |

Exports the given list of normal surfaces as a plain text CSV (comma-separated value) file, using edge weight coordinates.

CSV files are human-readable and human-editable, and are suitable for importing into spreadsheets and databases.

The surfaces will be exported in edge weight coordinates. Thus there will be one coordinate for each edge of the underlying triangulation; each such coordinate will become a separate field in the CSV file.

As well as the normal surface coordinates, additional properties of the normal surfaces (such as Euler characteristic, orientability, and so on) can be included as extra fields in the export. Users can select precisely which properties to include by passing a bitmask, formed as a bitwise or combination of constants from the regina::SurfaceExportFields enumeration type.

The CSV format used here begins with a header row, and uses commas as field separators. Text fields with arbitrary contents are placed inside double quotes, and the double quote character itself is represented by a pair of double quotes. Thus the string `my "normal" surface's name` would be stored as `"my ""normal"" surface's name"`.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. Any user strings such as surface names will be written in UTF-8.

Parameters

  filename | the name of the CSV file to export to.
  additionalFields | a bitwise combination of constants from regina::SurfaceExportFields indicating which additional properties of surfaces should be included in the export.

Returns
  `true` if the export was successful, or `false` otherwise.

## saveCSVStandard()

bool regina::NormalSurfaces::saveCSVStandard | ( | const char * | filename,
|  | int | additionalFields = `regina::surfaceExportAll`
| ) |  |

Exports this list of normal surfaces as a plain text CSV (comma-separated value) file, using standard coordinates.

CSV files are human-readable and human-editable, and are suitable for importing into spreadsheets and databases.

The surfaces will be exported in standard coordinates (tri-quad coordinates for normal surfaces, or tri-quad-oct coordinates for almost normal surfaces). Each coordinate will become a separate field in the CSV file.

As well as the normal surface coordinates, additional properties of the normal surfaces (such as Euler characteristic, orientability, and so on) can be included as extra fields in the export. Users can select precisely which properties to include by passing a bitmask, formed as a bitwise or combination of constants from the regina::SurfaceExportFields enumeration type.

The CSV format used here begins with a header row, and uses commas as field separators. Text fields with arbitrary contents are placed inside double quotes, and the double quote character itself is represented by a pair of double quotes. Thus the string `my "normal" surface's name` would be stored as `"my ""normal"" surface's name"`.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. Any user strings such as surface names will be written in UTF-8.

Parameters

  filename | the name of the CSV file to export to.
  additionalFields | a bitwise combination of constants from regina::SurfaceExportFields indicating which additional properties of surfaces should be included in the export.

Returns
  `true` if the export was successful, or `false` otherwise.

## setLabel()

void regina::Packet::setLabel | ( | const std::string & | label | ) |

inherited

Sets the label associated with this individual packet.

Parameters

  label | the new label to give this packet.

## size()

size_t regina::NormalSurfaces::size | ( |  | ) | const

inline

Returns the number of surfaces stored in this list.

Returns
  the number of surfaces.

## sortChildren()

void regina::Packet::sortChildren | ( |  | ) |

inherited

Sorts the immediate children of this packet according to their packet labels.

Note that this routine is not recursive (for instance, grandchildren will not be sorted within each child packet).

This routine takes quadratic time in the number of immediate children (and it's slow quadratic at that).

## standardANToQuadOct()

NormalSurfaces* regina::NormalSurfaces::standardANToQuadOct | ( |  | ) | const

Converts the set of all embedded vertex almost normal surfaces in standard tri-quad-oct space to the set of all embedded vertex almost normal surfaces in the smaller quadrilateral-octagon space.

This routine is the almost normal analogue to the standardToQuad() conversion routine; see the standardToQuad() documentation for further information.

Precondition
  The underlying triangulation (the parent packet of this normal surface list) is valid, and the link of every vertex is either a sphere or a disc.
  This normal surface list is precisely the set of all embedded vertex almost normal surfaces in standard tri-quad-oct space; no more, no less. Typically this means that it was obtained through enumerate(), with the coordinate system set to NS_AN_STANDARD and with embeddedOnly set to `true`.

Returns
  a full list of vertex almost normal surfaces in quadrilateral-octagon coordinates, or 0 if any of the basic sanity checks failed.

## standardToQuad()

NormalSurfaces* regina::NormalSurfaces::standardToQuad | ( |  | ) | const

Converts the set of all embedded vertex normal surfaces in standard (tri-quad) space to the set of all embedded vertex normal surfaces in quadrilateral space.

The initial list in standard space is taken to be this normal surface list; the final list in quadrilateral space will be inserted as a new child packet of the underlying triangulation (specifically, as the final child). As a convenience, the final list will also be returned from this routine.

This routine can only be used with normal surfaces, not almost normal surfaces. For almost normal surfaces, see the similar routine standardANToQuadOct().

This procedure is available for any triangulation whose vertex links are all spheres and/or discs. The underlying algorithm is described in detail in "Converting between quadrilateral and standard solution sets in normal surface theory", Benjamin A. Burton, Algebr. Geom. Topol. 9 (2009), 2121-2174.

It should be noted that this routine does not simply convert vectors from one form to another; instead it converts a full solution set of vertex surfaces in standard coordinates to a full solution set of vertex surfaces in quadrilateral coordinates. Typically there are far fewer vertex surfaces in quadrilateral coordinates (all of which this routine will find).

This routine will run some very basic sanity checks before starting. Specifically, it will check the validity and vertex links of the underlying triangulation, and will verify that the coordinate system and embedded-only flag are set to NS_STANDARD and `true` respectively. If any of these checks fails, this routine will do nothing and return 0.

Precondition
  The underlying triangulation (the parent packet of this normal surface list) is valid, and the link of every vertex is either a sphere or a disc.
  This normal surface list is precisely the set of all embedded vertex normal surfaces in standard (tri-quad) space; no more, no less. Moreover, these vectors are stored using standard coordinates. Typically this means that this list was obtained through enumerate(), with the coordinate system set to NS_STANDARD and with embeddedOnly set to `true`.

Returns
  a full list of vertex normal surfaces in quadrilateral coordinates, or 0 if any of the basic sanity checks failed.

## str()

std::string regina::Output< Packet , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## surface()

const NormalSurface * regina::NormalSurfaces::surface | ( | size_t | index | ) | const

inline

Returns the surface at the requested index in this set.

Parameters

  index | the index of the requested surface in this set; this must be between 0 and size()-1 inclusive.

Returns
  the normal surface at the requested index in this set.

## swapWithNextSibling()

void regina::Packet::swapWithNextSibling | ( |  | ) |

inherited

Swaps this packet with its next sibling in the sequence of children beneath their common parent packet.

Calling this routine is equivalent to calling moveDown().

This routine takes small constant time.

If this packet has no next sibling then this routine does nothing.

## tags()

const std::set< std::string > & regina::Packet::tags | ( |  | ) | const

inline inherited

Returns the set of all tags associated with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Python:
  This routine returns a python list of strings.

Returns
  the set of all tags associated with this packet.

## totalTreeSize()

size_t regina::Packet::totalTreeSize | ( |  | ) | const

inherited

Determines the total number of packets in the tree or subtree for which this packet is matriarch.

This packet is included in the count.

Returns
  the total tree or subtree size.

## transferChildren()

void regina::Packet::transferChildren | ( | Packet * | newParent | ) |

inherited

Cuts all of this packet's children out of the packet tree, and reinserts them as children of the given packet instead.

The children of this packet will be appended to the end of the new parent's child list, in the same order as they were previously.

This is equivalent to calling reparent() on each child, but should be somewhat faster if there are many children to move.

Precondition
  None of the children of this packet depend on their current parent; see dependsOnParent() for details.
  The given parent is not a descendant of this packet.

Parameters

  newParent | the new parent beneath which the children will be inserted.

## triangulation()

Triangulation<3>* regina::NormalSurfaces::triangulation | ( |  | ) | const

Returns the triangulation in which these normal surfaces live.

Returns
  the triangulation in which these surfaces live.

## type()

virtual PacketType regina::Packet::type | ( |  | ) | const

pure virtual inherited

Returns the unique integer ID representing this type of packet.

This is the same for all packets of this class.

Returns
  the packet type ID.

## typeName()

virtual std::string regina::Packet::typeName | ( |  | ) | const

pure virtual inherited

Returns an English name for this type of packet.

An example is `Triangulation3`. This is the same for all packets of this class.

Returns
  the packet type name.

## unlisten()

bool regina::Packet::unlisten | ( | PacketListener * | listener | ) |

inherited

Unregisters the given packet listener so that it no longer listens for events on this packet.

See the PacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to unregister.

Returns
  `true` if the given listener was successfully unregistered, or `false` if the given listener was not registered in the first place.

## utf8()

std::string regina::Output< Packet , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## which()

NormalList regina::NormalSurfaces::which | ( |  | ) | const

inline

Returns details of which normal surfaces this list represents within the underlying triangulation.

This may not be the same NormalList that was passed to enumerate(). In particular, default values will have been explicitly filled in (such as NS_VERTEX and/or NS_EMBEDDED_ONLY), and invalid and/or redundant values will have been removed.

Returns
  details of what this list represents.

## writeAllSurfaces()

void regina::NormalSurfaces::writeAllSurfaces | ( | std::ostream & | out | ) | const

Writes the number of surfaces in this set followed by the details of each surface to the given output stream.

Output will be over many lines.

Python:
  Parameter out is not present and is assumed to be standard output.

Parameters

  out | the output stream to which to write.

## writeTextLong()

virtual void regina::NormalSurfaces::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent Packet class offers a reasonable default implementation.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::Packet.

## writeTextShort()

virtual void regina::NormalSurfaces::writeTextShort | ( | std::ostream & | out | ) | const

virtual

Writes a short text representation of this object to the given output stream.

This must be reimplemented by subclasses.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Implements regina::Packet.

## writeXMLFile()

void regina::Packet::writeXMLFile | ( | std::ostream & | out | ) | const

inherited

Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format.

Ths is similar to calling save(), except that (i) the user has a more flexible choice of output stream, and (ii) the XML will always be written in plain text (i.e., it will not be compressed).

If you simply wish to save your data to a file on the filesystem, you should call save() instead.

Typically this will be called from the root of the packet tree, which will write the entire packet tree to the output stream.

The output from this routine cannot be used as a piece of an XML file; it must be the entire XML file. For a piece of an XML file, see routine writeXMLPacketTree() instead.

Precondition
  This packet does not depend upon its parent.

Python:
  The argument out is not present; instead the XML data is written to standard output.

Parameters

  out | the output stream to which the XML data file should be written.

## writeXMLPacketData()

virtual void regina::NormalSurfaces::writeXMLPacketData | ( | std::ostream & | out | ) | const

protected virtual

Writes a chunk of XML containing the data for this packet only.

You may assume that the packet opening tag (including the packet type and label) has already been written, and that all child packets followed by the corresponding packet closing tag will be written immediately after this routine is called. This routine need only write the internal data stored in this specific packet.

Parameters

  out | the output stream to which the XML should be written.

Implements regina::Packet.

## writeXMLPacketTree()

void regina::Packet::writeXMLPacketTree | ( | std::ostream & | out | ) | const

protected inherited

Writes a chunk of XML containing the subtree with this packet as matriarch.

This is the preferred way of writing a packet tree to file.

The output from this routine is only a piece of XML; it should not be used as a complete XML file. For a complete XML file, see routine writeXMLFile() instead.

Parameters

  out | the output stream to which the XML should be written.

## Member Data Documentation

## algorithm_

NormalAlg regina::NormalSurfaces::algorithm_

protected

Stores the details of the enumeration algorithm that was used to generate this list.

This might not be the same as the algorithmHints flag passed to the corresponding enumeration routine (e.g., if invalid or inappropriate flags were passed).

## coords_

NormalCoords regina::NormalSurfaces::coords_

protected

Stores which coordinate system is being used by the normal surfaces in this packet.

## surfaces

std::vector<NormalSurface*> regina::NormalSurfaces::surfaces

protected

Contains the normal surfaces stored in this packet.

## which_

NormalList regina::NormalSurfaces::which_

protected

Indicates which normal surfaces these represent within the underlying triangulation.

The documentation for this class was generated from the following file:

- surfaces/normalsurfaces.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).